<template>
	<f7-page 
		name="home" 
		@page:beforein="onPageBeforeIn"
		@page:beforeout="onPageBeforeOut"
		ptr 
        @ptr:refresh="onPageRefresh">
		<!-- Top Navbar -->
		<f7-navbar :sliding="false" large title-large="Beranda">
			<f7-nav-right>Halo {{ user.profile.fullname }}...</f7-nav-right>
			<f7-nav-right>
				<f7-link href="/notifications/">
					<f7-icon ios="f7:bell" aurora="f7:bell" md="f7:bell" class="icon f7-icons">
						<f7-badge color="red">{{ total_notification.kformat() }}</f7-badge>					
					</f7-icon>
				</f7-link>
			</f7-nav-right>
		</f7-navbar>

		<!-- Page content-->
		<f7-block-title v-if="user.role.slug != 'public' && !announcementLoading && announcements.length > 0" class="swiper-title menu-grid-title">Update Terakhir</f7-block-title>

		<f7-block v-if="!announcementLoading && user.role.slug != 'public' && announcements.length > 0">			
			<f7-swiper class="card-swipe" :params="{loop: announcements.length > 1, speed:900, slidesPerView: announcements.length > 1 ? 2 : 1, spaceBetween: 20, centeredSlides:true}">
				<f7-swiper-slide v-for="item in announcements" v-bind:key="item.id">
					<f7-card @cardBeforeOpen="hideTitle" @cardClose="showTitle" @cardOpened="setSwipeOff" @cardClosed="setSwipeOn" expandable style="height:200px;">
						<f7-card-content :padding="false" class="first">
							<div :class="bgColors.random()" :style="{height: '200px'}">
								<f7-card-header text-color="white" class="display-block">
									<span class="card-header-title">{{ item.category.name }}</span>
									<br />
									<small class="card-header-subtitle display-block">{{ item.title }}</small>
									<small class="card-datetime display-block">{{ dateFormat(item.updated) }}</small>
								</f7-card-header>
								<f7-link card-close color="white" class="card-opened-fade-in" :style="{position: 'absolute', right: '15px', top: '15px'}" icon-f7="close_round"></f7-link>
							</div>
							<div class="card-content-padding">
								<strong class="display-block">{{ item.residentials[0].administrative_region[2].replace(/(Kota|Kab)/g, '')+', '+dateFormat(item.updated, 'DD MMMM YYYY') }}</strong>
								<br>
								<ul style="list-style:none;padding-left:0;">
									<li>
										<strong style="display:block;width:100px;margin-right:10px;float:left">No</strong>: {{ item.number }}
									</li>
									<li>
										<strong style="display:block;width:100px;margin-right:10px;float:left">Perihal</strong>: {{ item.title }}
									</li>
									<li>
										<strong style="display:block;width:100px;margin-right:10px;float:left">Lampiran</strong>: {{ item.medias.length > 0 ? item.medias.length : '-' }}
									</li>
								</ul>
								<br>
								<p>Kepada Yth. <br>Warga {{ item.residentials[0].name }}<br>{{ item.residentials[0].address }}, {{ item.residentials[0].administrative_region[0] }}, {{ item.residentials[0].administrative_region[1] }}, <br>{{ item.residentials[0].administrative_region[2] }}, {{ item.residentials[0].administrative_region[3] }}, {{ item.residentials[0].administrative_region[4] }}</p>
								<br>
								<div v-html="item.body">
									{{ item.body }}
								</div>
								<br>
								<f7-row v-if="item.signs.length > 0">
									<f7-col v-for="sign in item.signs" v-bind:key="sign.id">
										<u>{{ sign.name }}</u><br>{{ sign.position }}
									</f7-col>
								</f7-row>
								<br>
								<h3 v-if="item.medias != null"><f7-icon f7="attachment"></f7-icon> Lampiran</h3>
								<ul v-if="item.medias != null"  style="list-style:none;padding-left:0;">
									<li v-for="media in item.medias" v-bind:key="media.id" style="border-top:1px solid #eee;padding-top:10px;padding-bottom: 10px;">
										<f7-button v-if="['image/jpg', 'image/jpeg', 'image/png'].indexOf(media.mimetype) > -1" color="smoothgray" @click="showMedia(item)" class="text-align-left"> 
											<f7-icon size="18" f7="images" class="margin-small-right"></f7-icon> 
											{{ media.original_filename }}
										</f7-button>
										<f7-button v-else :href="media.url" :download="media.url" external color="smoothgray"> 
											<f7-icon size="18" f7="document_text" class="margin-small-right"></f7-icon>
											{{ media.original_filename }}
										</f7-button>
									</li>
								</ul>
							</div>
						</f7-card-content>
					</f7-card>
				</f7-swiper-slide>
			</f7-swiper>
		</f7-block>
		<f7-card
			v-if="user.role.slug != 'public' && announcementLoading"
			class="skeleton-text"
			title="Card Header"
			content="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi lobortis et massa ac interdum. Cras consequat felis at consequat hendrerit."
			footer="Card Footer"
		></f7-card>
		
		<f7-block v-if="user.role.slug != 'public'" class="menu-grid">
			<f7-row>
				<f7-col class="text-align-center">
					<f7-link href="/announcements/" class="display-block" color="gray">
						<span class="icon-border">
							<f7-icon f7="logo_rss" size="30px" color="orange"></f7-icon>
						</span>
						<span class="text-uppercase color-black display-block margin-small-top margin-small-bottom">Berita</span>
					</f7-link>
				</f7-col>
				<f7-col class="text-align-center">
					<f7-link href="/resident-reports/" class="display-block" color="gray">
						<span class="icon-border">
							<f7-icon f7="volume" size="32px" color="green"></f7-icon>
						</span>
						<span class="text-uppercase color-black display-block margin-small-top margin-small-bottom">Aduan</span>
					</f7-link>
				</f7-col>
				<f7-col class="text-align-center">
					<f7-link href="/financial-reports/" class="display-block" color="gray">
						<span class="icon-border">
							<f7-icon f7="document_text" size="32px" color="blue"></f7-icon>
						</span>
						<span class="text-uppercase color-black display-block margin-small-top margin-small-bottom">Keuangan</span>
					</f7-link>
				</f7-col>
				<f7-col class="text-align-center">
					<f7-link href="/cctv/" class="display-block" color="gray">
						<span class="icon-border">
							<f7-icon f7="videocam" size="36px" color="deeppurple"></f7-icon>
						</span>
						<span class="text-uppercase color-black display-block margin-small-top margin-small-bottom">CCTV</span>
					</f7-link>
				</f7-col>
			</f7-row>
			<f7-row>
				<f7-col class="text-align-center">
					<f7-link href="/inventory/" class="display-block" color="gray">
						<span class="icon-border">
							<f7-icon f7="layers_alt" size="32px" color="yellow"></f7-icon>
						</span>
						<span class="text-uppercase color-black display-block margin-small-top margin-small-bottom">Aset Komplek</span>
					</f7-link>
				</f7-col>
				<f7-col class="text-align-center">
					<f7-link href="/contacts/" class="display-block" color="purple">
						<span class="icon-border">
							<f7-icon f7="phone" size="32px" color="purple"></f7-icon>
						</span>
						<span class="text-uppercase color-black display-block margin-small-top margin-small-bottom">No. Telp Penting</span>
					</f7-link>
				</f7-col>
				<f7-col class="text-align-center">
					<f7-link href="/products/" class="display-block" color="gray">
						<span class="icon-border">
							<f7-icon f7="tags" size="32px" color="red"></f7-icon>
						</span>
						<span class="text-uppercase color-black display-block margin-small-top margin-small-bottom">Iklan Saya</span>
					</f7-link>
				</f7-col>
				<f7-col class="text-align-center">
					<f7-link href="/info/" class="display-block" color="gray">
						<span class="icon-border">
							<f7-icon f7="info_round" size="32px" color="gray"></f7-icon>
						</span>
						<span class="text-uppercase color-black display-block margin-small-top margin-small-bottom">Info Ringsatu</span>
					</f7-link>
				</f7-col>
			</f7-row>	
			<f7-row>
				<f7-col width="25" class="text-align-center">
					<f7-link href="/panic/groups/" class="display-block" color="gray">
						<span class="icon-border">
							<f7-icon material="touch_app" size="32px" color="teal"></f7-icon>
						</span>
						<span class="text-uppercase color-black display-block margin-small-top margin-small-bottom">Grup Panik</span>
					</f7-link>
				</f7-col>
				<f7-col width="25" class="text-align-center">
					<f7-link href="/freebies/" class="display-block" color="gray">
						<span class="icon-border">
							<f7-icon material="sync" size="32px" color="black"></f7-icon>
						</span>
						<span class="text-uppercase color-black display-block margin-small-top margin-small-bottom">Barang Loak</span>
					</f7-link>
				</f7-col>
				<f7-col width="50" class="text-align-center"></f7-col>
			</f7-row>		
		</f7-block>	

		<!-- public menu -->
		<f7-block v-else class="menu-grid">
			<f7-row>
				<f7-col width="25" class="text-align-center">
					<f7-link href="/info/" class="display-block" color="gray">
						<span class="icon-border">
							<f7-icon f7="info_round" size="32px" color="orange"></f7-icon>
						</span>
						<span class="text-uppercase color-black display-block margin-small-top margin-small-bottom">Info RingSatu</span>
					</f7-link>
				</f7-col>
				<f7-col width="25" class="text-align-center">
					<f7-link href="/contacts/" class="display-block" color="lightgreen">
						<span class="icon-border">
							<f7-icon f7="phone" size="32px" color="lightgreen"></f7-icon>
						</span>
						<span class="text-uppercase color-black display-block margin-small-top margin-small-bottom">No.  Telp Penting</span>
					</f7-link>
				</f7-col>
				<f7-col width="25" class="text-align-center">
					<f7-link href="/panic/groups/" class="display-block" color="gray">
						<span class="icon-border">
							<f7-icon material="touch_app" size="32px" color="deeppurple"></f7-icon>
						</span>
						<span class="text-uppercase color-black display-block margin-small-top margin-small-bottom">Grup Panik</span>
					</f7-link>
				</f7-col>				
				<f7-col width="25" class="text-align-center">
					<f7-link href="/products/" class="display-block" color="gray">
						<span class="icon-border">
							<f7-icon f7="tags" size="32px" color="red"></f7-icon>
						</span>
						<span class="text-uppercase color-black display-block margin-small-top margin-small-bottom">Iklan Saya</span>
					</f7-link>
				</f7-col>
			</f7-row>
			<f7-row>
				<f7-col width="25" class="text-align-center">
					<f7-link href="/freebies/" class="display-block" color="gray">
						<span class="icon-border">
							<f7-icon material="sync" size="32px" color="black"></f7-icon>
						</span>
						<span class="text-uppercase color-black display-block margin-small-top margin-small-bottom">Barang Loak</span>
					</f7-link>
				</f7-col>
				<f7-col width="75" class="text-align-center"></f7-col>
			</f7-row>
		</f7-block>	
	</f7-page>
</template>

<script>
import { mapGetters } from 'vuex';
import { setTimeout } from 'timers';
import { dateFormat, hoursAgo, truncate, stripHTML, initial, distance} from '../js/utils';
export default {
	name: 'Home',
	data(){
		return {
			announcementLoading: true,
			allowInfinite: true,
			showPreloader: true,
		}
	},
	computed: {
		...mapGetters(['bgColors']),
		...mapGetters('auth', ['nid', 'user', 'total_notification']),
		...mapGetters('announcement', [
			'announcements'
		]),
		currentLocation: function(){
			const self = this;

			let currentLocation = localStorage.getItem('currentLocation') ? JSON.parse(localStorage.getItem('currentLocation')) : null;
			return currentLocation;
		}
	},
	methods: {
		dateFormat,
		hoursAgo,
		truncate,
		stripHTML,
		initial,
		distance,
        convertAmpersand(text){
            return text.replace(/&amp;/g, '&');
        },
        calculateDiscount(price, discount){
            return price - ((price * discount) / 100);
		},
		getTotalNotification(){
			const self = this;

			self.$store.dispatch('auth/getNotifications', {
				total_only: true
			});
		},
		getAnnouncements(){
			const self = this;
			const app = self.$f7;

			self.$store.dispatch('announcement/getAnnouncements', {
				status: 'publish',
				residential: self.user.residential != null ? self.user.residential.id : null,
				page: 1,
				perpage: 10,
				only: 'id,number,title,body,created,updated,category.id,category.name,medias.mimetype,medias.url,medias.filename,medias.original_filename,signs,residentials.name,residentials.address,residentials.administrative_region,author.id,author.profile,author.profile.fullname,author.profile.initial,author.profile.media'
			}).then(()=>{
				setTimeout(()=>{
					self.announcementLoading = false;
				}, 100);
			});
		},
		onPageBeforeIn(){
			const self = this;
			const app = self.$f7;

			if(self.user.role.slug != 'public'){
				self.getAnnouncements();
			}

			if(localStorage.getItem('nid') != null){
				window.plugins.OneSignal.getPermissionSubscriptionState(function(s){
					localStorage.setItem('nid', s.subscriptionStatus.userId);
					self.$store.dispatch('addDevice');
				});					
			}

			self.getTotalNotification();
			
		},
		onPageBeforeOut(page){
			const self = this;		
		},
		onPageRefresh(e, done){
			const self = this;
			const app = self.$f7;

            if(self.user.role.slug != 'public'){
				self.getAnnouncements();
			}	
			done();	
		},
		hideTitle(){
			const self = this;
			self.$$('.swiper-title').hide();
		},
		showTitle(){
			const self = this;
			self.$$('.swiper-title').show();
		},
		setSwipeOff() {
			const self = this;
			var mySwiper = self.$f7.swiper.get('.swiper-container');
			
			setTimeout(() =>{
				mySwiper.detachEvents();
			},100);
		},
		setSwipeOn() {
			const self = this;
			var mySwiper = self.$f7.swiper.get('.swiper-container');			
			setTimeout(() =>{
				mySwiper.attachEvents();				
			},100);
		},
		showMedia(item){
			const self = this;
			const app = self.$f7;

			const $$ = self.$$;

			if(item.medias != null){
                let medias = item.medias.map((x) => {
					if(['image/jpg', 'image/jpeg', 'image/png'].indexOf(x.mimetype) > -1){
						return x.url.original;
					}
				});
                let photoBrowser = app.photoBrowser.create({
                    photos: medias,
                    type: 'popup'
                }).open();
            }
		}	
	},
}
</script>
